/*
_ScriptBlock                     cseg     00006F97 0000000F
_ScriptAllow                     cseg     00006FA6 0000000F
_ScriptNew                       cseg     00006FB5 00000035
_ScriptWrite                     cseg     00006FEA 0000007E
_ScriptFirst                     cseg     00007068 0000001D
_ScriptNext                      cseg     00007085 0000001E
CmdScriptSize                    cseg     000070A3 00000021
CmdUnknown171                    cseg     000070C4 00000012
CmdUnknown172                    cseg     000070D6 00000020
*/

#include "types.h"
#include "error.h"

u16 script_size = 0x32;	// dseg:141
u16 script_count = 0;		// dseg:143	// number written in script
u16 temp = 0;			// dseg:5e1	// temp of script_count

u8 *script_head = 0;		// dseg:16FD	// top of script
u8 *script_next = 0;		// dseg:16ff
u8 *script_cur = 0;		// dseg:1701
u16 write_ok = 0;		// dseg:1703
u16 mem_script = 0;		// dseg:1705	used by cmdshowmem


void script_block()
{
	write_ok = 0;
}

void script_allow()
{
	write_ok = 1;
}

// initialise script
u8 *script_new()
{
	if (  (script_size > 0) && (script_head == 0)  )
	{
		script_head = malloc(script_size << 1);
		set_mem_rm0();
	}
	script_next = script_head;
	script_count = 0;
	return script_head;
}

void script_write(u16 var8, u16 vara)
{
	if (testflag(0x07) == 0)
	{
		if (write_ok != 0)
		{
			if (script_next >= ((script_size << 1) + script_head)  )
				set_agi_error(0xB, mem_script);
			script_next->0 = (u8)var8;
			script_next->1 = (u8)vara;
			script_next += 2;
			script_count++;
		}
		if (  ((script_next - script_head) / 2)  > mem_script)
			memscript = (script_next - script_head) / 2;
	}
}


// init some search?
void script_first()
{
	script_cur = script_head;
	script_next = script_head + (script_count << 1);
}

// return a ptr?  so the returning function can change it instead??
// get next script item
u8 *script_next()
{
	u8 *ax;

	if (script_cur >= script_next)
		ax = 0;
	else
	{
		ax = script_cur;
		script_cur += 2;
	}
	return ax;
}


u8 *cmd_script_size(u8 *c)
{
	script_size = *(c++);
	
	erase_both();
	script_new();
	blit_both();
	
	return c;
}

u8 *cmd_unknown_171(u8 *c)
{
	temp = script_count;
	return c;
}

u8 *cmd_unknown_172(u8 *c)
{
	script_count = temp;	
	script_next = script_head + (script_count << 1);
	return c;
}


