/*
j_EGAGrafMode                    cseg     00009740 00000003
j_EGATextMode                    cseg     00009743 00000003
j_EGAShowPic                     cseg     00009746 00000003
j_EGA4                           cseg     00009749 00000003
j_EGAPutBlock                    cseg     0000974C 00000003
j_EGAClear                       cseg     0000974F 00000003
j_EGAFilledRect                  cseg     00009752 00000003

// go into graphics mode
_EGAGrafMode                     cseg     00009755 00000020

// enter text mode
_EGATextMode                     cseg     00009775 0000003A

// enter graf mode and show a pic
_EGAShowPic                      cseg     000097AF 00000015

// i think to change the pallette.. not necessary in ega
_EGA4                            cseg     000097C4 00000001

// insert a rectangular block from the screen buff onto the frame buff
_EGAPutBlock                     cseg     000097C5 00000082

// insert a filled rectangle of a certain colour on the frame buff
// can also be used to make lines
_EGAFilledRect                   cseg     00009847 0000007C

// initialise the card.. creates a multiplication lookup table for putblock
_EGAInit                         cseg     000098C3 00000035

_EGAShake                        cseg     000098F8 0000005C
_SetWM2                          cseg     00009954 00000022
_SetWM0                          cseg     00009976 00000019
*/


void ega_graf_mode()
{
	ax = 0x0D;
	int86(0x10);	// set vid mode

	ah = 0x10;
	al = 0x3;
	bx = 0;
	int86(0x10);	// enable bg intensity

	// result is input from previous stage unmodified
	outp(0x3CE, 3);   // Graphics Address Register 
	outp(0x3CF, 0);   // Graphics Data Register 

	fbuff_seg = 0x0A000;
}

void ega_text_mode()
{
	u16 temp;
	ah = 0;
	al = 1;
	int86(0x10);	// text mode

	ah = 0x10;
	al = 3;
	bx = 0;
	int86(0x10);	// bg blinking

	ah = 1;
	cx = 0x1000;
	int86(0x10);	// cursor size (thin)
	
	ah = 2;
	bh = 0;
	dx = 0;
	int86(0x10);	// cursor pos (0,0) page 0

	al = (u8)text_comb;

	ah = 6;		// scroll page up
	al = 0;		// blank whole window
	cx = 0;		// top left corner
	dx = 0x1827;	// lower right corn
	int86(0x10);
	// clear the entire text window
}

void ega_show_pic()
{
	u16 temp;
	ega_graf_mode();
	show_pic();

}


void ega_4()
{
	// wheee.. do fucking nothing.. must be for cga
}

// ax lower left corner of block?
// al = y pos
// ah = x pos
// bl = width
// bh = height
void ega_put_block()
{
	si = calc_screen_off();
	di = frame_buff_off();
	bp = di;

	(push ds)
	(push es)

	es = fbuff_seg;
	ds = sbuff_seg;

	set_wm2();
	// set address to bit mask register
	// dx = 0x3CF
	// 3cf = Graphics Controller Data Register
	
	bob = ah AND 00000011b;
	ah = bl;
	di = bp;

	if (bob==0) goto pixel0;
	if (bob==1) goto pixel1;
	if (bob==2) goto pixel2;
	if (bob==3) goto pixel3;

pixel0:
	outp(dx, 0x0C0);	// 1100 0000
	al = *(es:di);		// get pixel info from frame buffer
	*(es:di++) = (u8)*(ds:si++);
	ah--;
	if (ah == 0)
		goto 982C;
	di--;
pixel1:
	outp(dx, 0x030);	// 0011 0000
	al = *(es:di);
	*(es:di++) = (u8)*(ds:si++);
	ah--;
	if (ah == 0)
		goto 982C;
	di--;
pixel2:
	outp(dx, 0x0C);		// 0000 1100
	al = *(es:di);
	*(es:di++) = (u8)*(ds:si++);
	ah--;
	if (ah == 0)
		goto 982C;
	di--;
pixel3:
	outp(dx, 0x3);		// 0000 0011
	al = *(es:di);
	*(es:di++) = (u8)*(ds:si++);
	ah--;
	if (ah != 0)
		goto pixel0;
982C:
	bh--;
	if (bh == 0)
		goto 9841;

	al = bl;
	si = si - 160 - bl;

	bp -= 40;
	di = bp;

	ah = bl;

	if (bob==0) goto pixel0;
	if (bob==1) goto pixel1;
	if (bob==2) goto pixel2;
	if (bob==3) goto pixel3;

9841:
	set_wm0();
	(pop es)
	(pop ds)
}











// f(x) = 0x28*x

// more like ega_init
void ega_clear()
{
	di = &mult_lookup_tab;
	ax = 0
	if (ax != *mult_lookup_tab)
	{
		// create a lookup table
		for (cx=0x0C8; cx!=0; cx--)
		{
			*di = ax;
			di += 2;
			ax += 0x28;
		}
		set_wm2();
		// set address to bit mask register
		// dx = 0x3CF
		(push es)
		(push ds)

		es = 0x0A000;
		ds = 0x0A000;
		di = 0x2000;
		for (cx=0x1F40; cx!=0; cx--)
		{
			outp(dx, 0x0FF);
			al = *(es:di);	// timing delay??
			al = 0;
			*di = al;
			di++;
		}

		(pop ds)
		(pop es)
	}
}








// return in di
// al = y pos
// ah = x pos
word calc_screen_off()
{
	di = 160*al + ah;
}


// di = (word136F + y) * 0x50 + x /4;
word frame_buff_off()
{
	/*
	di = &mult_lookup_tab;
	bx = (word136F + al) * 2;
	di = *(bx+di); //di = bx * 28h
	bx = ah;
	*/

	di = (word136F + al) * 0x50;
	bx = ah;

	if (display_type == 4)
		bx *= 2;
	if (computer_type == 0)
	{
		bx /= 2;
		if (display_type == 3)
			bx /= 2;
	}
	if (computer_type == 2)
	{
		if (display_type == 3)
		{
			bx /= 2;
			bx /= 2;
		}
	}
	di += bx;
}

void setwm2()
{
	/*
	set to write mode 2
	data is not affected by latch register
	set to bit mask register thingy
	dx = 3cf .. write to this port to change bitmask
	*/
}

void setwm0()
{
	/*
	set to write mode 0!
	set bitmask to FFh
	dx = 3cf .. write to this port to change bitmask
	*/
}


// al = y pos
// ah = x pos
// bl = width
// bh = height
// dx = colour!!  uses al?
void filled_rect(x,y,width, height, colour)
{
	es = fbuff_seg;

	si = (word136F + y)*40 + x/4;
	di = si;

	bob = ah AND 3;
	setwm2();

	bl = colour;
	bh = height
987c:
	ah = width


	if (bob == 0) goto zero;
	if (bob == 1) goto one;
	if (bob == 2) goto two;
	if (bob == 3) goto three;	
zero:
	al = 11000000b;		// bitmask
	outp(al, 3cfh);		// register bitmask
	al = *(es:di);		// al = current pixel info
	*(es:di) = bl;		// put in colour;
	ah--;
	if (ah == 0) goto 98b4;

one:
	al = 110000b;
	outp(al, 3cfh);
	al = *(es:di);
	*(es:di) = bl;
	ah--;
	if (ah == 0) goto 98b4;

two:
	al = 1100b;
	outp(al, 3cfh);
	al = *(es:di);
	*(es:di) = bl;
	ah--;
	if (ah == 0) goto 98b4;

three:
	al = 11b;
	outp(al, 3cfh);
	al = *(es:di);
	al = bl;
	*(es:di) = al;
	di++;
	ah--;
	goto zero;

98b4:
	si -= 0x28;		// pointer to frame buffer
	di = si;
	bh--;			// height
	if (bh != 0) goto 987c;
	set_wm0();
}

void box n border(u8 x, u8 y, u8 w, u8 h, u8 bg, u8 line)
{
	filled_rect(x,y, w, h, bg);		// white
	filled_rect(x+1, y-1, w-2, 1, line);	// bottom
	filled_rect(x-2+w, y-2, 1, h-4, line);	// right
	filled_rect(x+1, y-h+2, w-2, 1, line);	// top
	filled_rect(x+1, y-2-h, 1, h-4, line);	// left
}



u8 *cmd_shake(u8 *c)
{
	cx = *(c++);
	if ( display_type == 3) 
	{
		ega_shake();
	}
	else
	{
		// blah
	}
	return c;
}