/*
_EraseAll                        cseg     00000307 00000026
_FreeList                        cseg     0000032D 0000002B
_BuildBlitList                   cseg     00000358 000000D7
sub_cseg_42F                     cseg     0000042F 0000002F
_BlitAll                         cseg     0000045E 0000002A
_CheckMove                       cseg     00000488 00000051
CmdAnimateObj                    cseg     000004D9 0000001C
_AnimateObj                      cseg     000004F5 00000048
CmdUnanimateAll                  cseg     0000053D 00000026
_UpdateGraphics                  cseg     00000563 000000E1
_CalcDirection                   cseg     00000644 00000036
_UpdateMovement                  cseg     0000067A 0000005F
_CheckBlockStat                  cseg     000006D9 000000CF
*/


struct vt_entry
{
	byte steptime,
	byte steptime2,
	byte unknown2,
	word xpos,
	word ypos,
	byte currentview,

	word view_data_start,
	byte curr_loop,
	byte num_loops,

	word loop_data_start,
	byte curr_cel,
	byte num_cels,

	word cel_data_start,
	word cel_data_start2,
	word unknown14,
	
	word xpos_copy,
	word ypos_copy,

	word xsize,
	word ysize,
	byte step_size,
	byte cycle_time,
	byte cycle_time2,
	byte direction,
	byte motion_type,
	byte cycle_type,
	byte priority,
	word flags,
	byte unknown27,
	byte unknown28,
	byte unknown29,
	byte unknown2A
}



_EraseAll                        cseg     00000307 00000026
_FreeList                        cseg     0000032D 0000002B
_BuildBlitList                   cseg     00000358 000000D7
sub_cseg_42F                     cseg     0000042F 0000002F
_BlitAll                         cseg     0000045E 0000002A
_CheckMove                       cseg     00000488 00000051

others I could include.... maybe

CmdAnimateObj                    cseg     000004D9 0000001C
subAnimateObj                    cseg     000004F5 00000048
CmdUnanimateAll                  cseg     0000053D 00000026
_UpdateGraphics                  cseg     00000563 000000E1
_CalcDirection                   cseg     00000644 00000036
_UpdateMovement                  cseg     0000067A 0000005F
_CheckBlockStat                  cseg     000006D9 000000CF


VIEW *vt_start;
VIEW *vt_end;
VIEW *vt_size;
VIEW *vt_last;


; struct foo {
;	short f0;	// previous>?????
;	struct foo *next;
;	struct vt_entry *v;
;	short x_pos;
;	short y_pos;
;	short x_size;
;	short y_size;
;	char *buffer;
; }


void vt_new(u16 max)
{
	if (vt_start == 0)
	{
		vt_size = max * sizeof(view_node);
		vt_start = (void *)malloc(vt_size);
	}

	memset(vt_start, 0, vt_size);
	vt_end = vt_start + max * sizeof(view_node);
	vt_last = vt_end - sizeof(view_node);

	for (i=0, cur_vt=vt_start ; i<max ; i++, cur_vt++)
		cur_vt->unknown2 = i;
}


// pass a sprite list head
// erase list draws the screen back without the objects one by one.. like putting
// the peel of an onion back on or something..
u16 erase_all(BLIT *b)
{
	BLIT *cur;

	for (cur=b->prev ; cur!=0 ; cur=cur->prev)
	{
		restore_area(cur);
	}
	
	return free_list(b);	
}

// set_memptr2() is the same as set_mem_ptr()
// you can think of it as a weird free() command.. it frees up everything 
// that had been allocated from that point.
// NOT good if something else had been allocated after the sprite list head
u16 free_list(BLIT *b)
{
	BLIT *s, *d;
	
	for (s=b->prev ; s!=0 ; s = d)
	{
		d = s->prev;
		free(s);	// set_memptr2(si);
	}
	
	b->next = 0;	// prev
	b->prev = 0;	// next
	return 0;
}

// view tables... man
void build_blit_list(func8, varA)	// function, spritelist
{
	//u16 *var40a;	// 0x202
	u16 priority[256];	//408	it's priority
	u16 cur_pri;	// 0x202	priority
	
	u16 view[256];	//206	position of vtable in mem
	
	u16 i;
	u16 num;	
	u16 next;
	
	num = 0;
	for (si=vt_start ; si<vt_end ; si+=0x2B)
	{
		if (func8(si) != 0)
		{	
			view[num] = si;
			
			if ( (si ->flags & 0x4) != 0)	// unknown flag
				priority[num] = 12*( (si->0x24) - 1);	// sub4CBB  0x24= priority
			else
				priority[num] = si->0x5;		// ypos

			num++;
		}
	}
	
	for (i=0 ; i<num ; i++)
	{
		cur_pri = 255;
		
		for (di=0; di<num; di++)
		{
			if (priority[di] < cur_pri )
			{
				next = di;
				cur_pri = priority[di];
			}
		}
		
		priority[next] = 255;
		sub42f( view[next], varA );
	}
	
	return varA;	// a passed parameter
}


void sub42f(var8, varA)
{
	si = varA;
	
	di = debug_8fd0(var8);
	di->0 = si->0;
	
	if (si->0 != 0)
	{
		bx = di->0;
		bx->2 = di;
	}
	
	si->0 = di;
	if (si->2 == 0) si->2 = di;
}

// not in this module.. actually at 8DF0.. called by show_obj() too
// create a BLIT thingy
sprite_list *debug_8fd0(VIEW v)
{
	si = v;
	di = malloc(0x10);
	
	di->0 = 0;
	di->2 = 0;
	di->4 = si;
	di->6 = si->3;		// v->x_pos
	di->8 = si->5 - si->0x1C + 1;	// v->y_pos - v->y_size +1
	di->0xA = si->0x1A;		// v->x_size
	
	/*if (display_type == 2)	// HGC man
	{
		// do boring HGC stuff that I frankly don't care about.
		// probably to take into account the higher res
	}*/

	di->0xC = si->0x1C;		// v->y_size
	di->0xE = malloc(si->0x1A * si->0x1C);
	
	si->0x14 = di;	// v->foo_struct
	
	return di;
}


void blit_all(var8)
{
	for ( si=var8->2 ; si !=0 ; si=si->2 )
	{
		objs_save_area(si);
		obj_blit(si->4);
	}
}


void check_move(FOO *s)
{
	bx = s;
	si = bx->0
	
	for ( si=bx->0 ; si !=0 ; si=si->0 )
	{
		di = si->4;	// view table
		draw_new_cel(di);
		if (di->1 == di->0)
		{
			if (  (di->3 == di->0x16) && (di->5 == di->0x18)  )
			{
				di->0x25 = di->25 | 0x4000;	// bit 14
			}
			else
			{
				di->0x16 = di->3;
				di->0x18 = di->5;
				di->0x25 = di->25 & 0xBFFF;
			}
		}
	}
}

// used by lots of things..  first time I implemented it and it's not
// in this module either
void draw_new_cel(VIEW v)
{
}


u8 *cmd_animate_obj(u8 *c)
{
	animate_obj(*(c++));
	return c;	
}

void animate_obj(u8 num)
{
	VIEW *v;
	
	v = vt_start + num * sizeof(VIEW);
	
	if (v >= vt_end)
		set_agi_error(0x0D, num);
	if (  (v->flags & 0x40) == 0)
	{
		v->flags = 0x70;
		v->motion = 0;
		v->cycle = 0;
		v->direction = 0;
	}
}

void cmd_unanimate_all()
{
}


u8 array8d5[] = {4,4,0,0,0,4,1,1,1,0};
u8 array8df[] = {4,3,0,0,0,2,1,1,1,0};

void update_graphics()
{
	u8 temp;
	u16 touched; // di
	VIEW *v;	// si

	touched = 0;
	v = vt_start;

	for (v=vt_start; v < vt_end; v += sizeof(VIEW))
	{
		if (v->flags & 0x51 == 0x51)	// 101 0001b
		{
			// good for 65535 touchings
			touched++;
			temp = 4;
	
			if (v->flags & 0x2000 == 0)	// 0 = loop released, 1 = loop fixed
				if (v->num_loops == 2) || (v->num_loops == 3)
					temp = array8d5[ v->direction ];
				else
					if (v->num_loops == 4)
						temp = array8df[ v->direction ];
	
			if (v->steptime2 == 1) && (temp != 4) && (v->curr_loop != temp)
				set_loop(v, temp);
	
			if (v->flags AND 20h != 0) && (v->cycle_time2 != 0)	// 0 = stop cycling, 1 = cycling
			{
				(v->cycle_time2)--;	// cycle time
				if (v->cycle_time2 == 0)
				{
					update_view(v);
					v->cycle_time2 = v->cycle_time;
				}
			}
		}
	}

// clean up
	if (touched != 0)
	{
		erase_all(&sprite_list_head_1);
		sub150a();	// just called by this function
		blit_all(build_blit_list_1());
		check_move(&sprite_list_head_1);
		vt_start->flags = vt_start->flags & 0xF6FF;	// water/land
	}

}

void calculate_direction()
{
	for (si=vt_start ; si<vt_end ; si+=sizeof(view_node) )
	{
		if (si->flags & 0x51 == 0x51)
			if (si->steptime2 == 1)
				update_movement(si);
		
	}
}

void update_movement(view_node *given_node)
{
	si = given_node;
	ax = si->motion_type;
	if (ax == 1)
		calc_wander_dir(si);
	else if (ax == 2)
		calc_follow_dir(si);
	else if (ax == 3)
		calc_move_dir(si);
	
	if (block_set == 0)
		si->flags = si->flags AND 0FF7F;	// bit 7
	else
	{
		if (si->flags AND 2h == 0) && (si->direction != 0)	// 2(0) observe blocks
		{
			check_block_stat();
		}
	}
}

void check_block_stat(view_node *given_node)
{
	word temp2;
	word temp4;
	word temp6;

	si = given_node;
	temp4 = si->xpos;
	temp6 = si->ypos;
	temp2 = check_block(temp4, temp6);
	ax = si->direction;

	if (ax == 1)
		temp6 -= si->step_size;
	else if (ax == 2)
	{
		temp4 += si->step_size;
		temp6 -= si->step_size;
	}
	else if (ax == 3)
		temp4 += si->step_size;
	else if (ax == 4)
	{
		temp4 += si->step_size;
		temp6 += si->step_size;
	}
	else if (ax == 5)
		temp6 += si->step_size;
	else if (ax == 6)
	{
		temp4 -= si->step_size;
		temp6 += si->step_size;
	}
	else if (ax == 7)
		temp4 -= si->step_size;
	else if (ax == 8)
	{
		temp4 -= si->step_size;
		temp6 -= si->step_size;
	}

	if (temp2 == check_block(temp4, temp6) )
		si->flags = si->flags AND 0FF7Fh;
	else
	{
		si.flags = si.flags OR 80h;
		si.direction = 0;
		if (vt_start == si)
			agi_var[V06_DIRECTION] = 0;
	}
}
