/*
_InitViewList                    cseg     0000395E 0000000F
_FreeViewList                    cseg     0000396D 0000000C
_FindView                        cseg     00003979 00000038
CmdLoadView                      cseg     000039B1 0000001F
CmdLoadViewV                     cseg     000039D0 00000027
_LoadView                        cseg     000039F7 00000080

CmdSetView                       cseg     00003A77 00000034
CmdSetViewV                      cseg     00003AAB 0000003C
_SetView                         cseg     00003AE7 00000060

CmdSetLoop                       cseg     00003B47 00000034
CmdSetLoopV                      cseg     00003B7B 0000003C
_SetLoop                         cseg     00003BB7 00000064
_SetLoop2                        cseg     00003C1B 0000003A

CmdSetCel                        cseg     00003C55 00000037
CmdSetCelV                       cseg     00003C8C 0000003F
_CheckCel                        cseg     00003CCB 0000009F
_SetCel                          cseg     00003D6A 00000035
CmdLastCel                       cseg     00003D9F 0000004E
CmdCurrentCel                    cseg     00003DED 00000038
CmdCurrentLoop                   cseg     00003E25 00000038
CmdCurrentView                   cseg     00003E5D 00000038
_NumOfLoops                      cseg     00003E95 00000038

CmdDiscardView                   cseg     00003ECD 0000001C
CmdDiscardViewV                  cseg     00003EE9 00000024
_DiscardView                     cseg     00003F0D 0000004A
*/



struct view_node_struct
{
	struct view_node_struct *next;	// 0
	u8 num;					// 2 view_num
	u8 *data;					// 3 data
};
typedef view_node_struct VIEW_NODE;

VIEW_NODE view_list_head = {0,0,0};
u16 prev_view = 0;

void init_view_list()
{
	view_list_head = 0;
}

void free_view_list()
{
	init_view_list();
}

VIEW_NODE *find_view(u16 num)
{
	VIEW_NODE *prev, *cur;
	
	cur = view_list_head->next;
	prev = &view_list_head;

	while (  (cur!=0) && ( num!=(cur->num))  )
	{
		prev = cur;
		cur = cur->next;
	}

	prev_view = prev;	// find, load and discard
	return cur;
}
	
	
u8 *cmd_load_view(u8 *c)
{
	load_view(*(c++), 0);
	return c;
}

u8 *cmd_load_view_v(u8 *c)
{
	load_view(var_array[*(c++)], 0);
	return c;
}


VIEW_NODE *load_view(u16 num, u8 *data)
{
	VIEW_NODE v;
	v = find_view(num);
	
	if ( (v != 0) && (data == 0) ) return v;
	
	erase_both();
	
	if (v == 0)
	{
		script_write(1, num);
		v = malloc(0x5);
		prev_view->next = v;
		v->next = 0;
		v->num = num;
		v->data = 0;
	}
	
	v->data = load_res(check_res_view(v->num), v->data);
	if (v->data == 0) return 0;
		
	//sub5857(v->data);	cga_thing
	blit_both();
	return v;
}

// .........

u8 *cmd_discard_view(u8 *c)
{
	discard_view(*(c++) );
	return c;
}

u8 *cmd_discard_view_v(u8 *c)
{
	discard_view(var_array[*(c++)]);
	return c;
}

void discard_view(u16 num)
{
	si = find_view(num);
	if (si == 0)
	{
		set_agi_error(1, num);
	}
	script_write(7, num);
	prev_view->next = 0;
	eraseboth();
	free(si);
	//set_mem_ptr(si);
	blit_both()
	update_var8();
}

#warning check the malloc() and free() stuff. .
#warning what if you run discard on a view object that points to another??