/*
locObjsSaveArea		cseg     00009CF0 00000003
locObjsRtreArea			cseg     00009CF3 00000003
locObjBlit				cseg     00009CF6 00000003
subIBMSaveArea		cseg     00009CF9 0000003F
subIBMRstrArea			cseg     00009D38 0000003D
subIbmBlit				cseg     00009D75 000000D0
*/


struct foo
{
	u16 f0;				//0
	struct foo *next;		//2
	struct vt_entry *v;		//4
	u16 x_pos;			//6
	u16 y_pos;			// 8
	u16 x_size;			// A
	u16 y_size;			// C
	u8 *buffer;			// E
	something				 //10h
}	



// in the struct.. it's pointing to the area that it's saved from the screen buffer
// to the new buffer

// remember.. ds = es = ds..  
void save_area(foo *param)
{
	u8 x_size, y_size;	// ah = y, al = x
	u8 *cur_sbuff, *b_buff;	// screen buff (si) and blit buf (di)
	u16 cx;
	
	cur_sbuff = s_buff + 160 * param->y_pos + param->x_pos;	// calc_screen_off()
	b_buff = param -> buffer;
	y_size = param -> y_size;
	x_size = param -> x_size;
	
	do
	{
		cx = x_size;
		while (cx != 0)
		{
			*(b_buff++) = *(cur_sbuff++);
			cx--;
		}
		cur_sbuff += 160 - x_size;
		y_size--;
	} while (y_size != 0);
}

void restore_area(foo *param)
{
	u8 x_size, y_size;	// ah = y, al = x
	u8 *cur_sbuff, *b_buff;	// screen buff (di) and blit buf (si)
	u16 cx;

	cur_sbuff = s_buff + 160 * param->y_pos + param->x_pos;	// calc_screen_off()
	b_buff = param -> buffer;
	y_size = param -> y_size;
	x_size = param -> x_size;
	
	do
	{
		cx = x_size;
		while (cx != 0)
		{
			*(cur_sbuff++) = *(b_buff++);
			cx--;
		}
		cur_sbuff += 160 - x_size;
		y_size--;
	} while (y_size != 0);
}

// return in di
// al = y pos
// ah = x pos
word calc_screen_off()
{
	di = 160*al + ah;
}

void blit_area(VIEW *v)
{
	u16 temp;
	u8 *si;
	VIEW *bp;
	
	u8 height;
	u8 invisible;		// 1 invisible, 0 not
	u8 chunk;
	u8 col, len;
	
	/*
	bh = priority shifted right 
	bl = flag..  1 is invisible.. 0 not
	dl = height
	dh = mirror info
	*/
	
	bp = v;
	al = v -> 2;	// ?
*	push ax;
	si = v -> 10h;	// start of cel data!!
	
	// reverse??
	if (  ( si[0x2] & 0x80) != 0  )	// 1000 0000
	{
		sub57b5(bp);	// mirror cell
		si = bp->0x10;
	}
	
	si++;		// skip width of cell??
	height = *(si++);	// height
	dh = *(si++);	// trans/mirror info

	di = 160*( (bp->5) - height + 1) + (bp->3);	// 5=y 3=x
	
	dh = dh << 4;	// shifting.. trans info
	//push es;
	//es = sbuff_seg;
	invisible = 1;
	bh = (bp->0x24) << 4;	// priority
	bp = di;
	cx = 0;

loc9dca:
	chunk = *(si++);	// get next "chunk"
	if (chunk == 0)	// eol
	{
		height--;
		if (height == 0) goto loc9e2a;	// finish up and return function
		bp += 160;
		di = bp;
		goto loc9dca;
	}

	col = chunk & 0xF0;	// colour	// ah
	al = chunk & 0x0F;	// length 	// al
	if (col == dh) 	// colour is transparent
	{
		di += al;
		goto loc9dca;
	}

	cl = al;
	col = col >> 4;
loc9de2:
	al = *(es:di) & 0xF0;			// get priority
	if (al <= 0x20) goto loc9e06;	// control lines??
	if (al > bh) goto loc9e25;
	al = bh;
loc9df1:
	*(es:di) = al | col;
	invisible = 0;
	cx--;
	if (cx != 0) goto loc9de2;
		
	goto loc9dca;
	
// priority stuff??
	
loc9e06:
*	push di;
	ch = 0;
loc9e09:
	if (di >= (160*167) ) goto loc9e1e;
	di += 160;
	ch = *(es:di) & 0xF0;
	if (ch <= 0x20) goto loc9e09;
loc9e1e:
* 	pop di;
	temp = ch;
	ch = 0;
	if (temp <= bh) goto loc9df1;
loc9e25:
	di++;
	cx--;
	if (cx != 0) goto loc9de2;
	goto loc9dca;
	
	// finish up
	
loc9e2a:
//*	pop es;
* 	pop ax;
	if (al == 0)	// if view 0
	{	
		if ( invisible == 0 ) 
			reset_flag(1);	// not-invisible
		else
			set_flag(1);	// the invisible man
	}
	
}



// si = start of cel data!!
void sub57b5(VIEW *v)
{
	//u16 var2
	bp = v;
	bl = si->2;
	al = ( (si->2) & 0x70 ) >> 4;
	cl = 4;
	ah = v->0xa;	// current loop
	
	if (al != ah)
	{
		al = 0x70;
		al = ~al;		// not
		al = al & bl;
		al = al << 1;
		al = al | ah;
		si->2 = al;
		//sp = sp - 0x800;
		di = malloc(0x800);
	}
loc5850:
}